;*****************************************************************************
; MACROS:	Some Common MACROS
;
; Author	Wim de Vree, pe1grl@amsat.org
; Revision history
; 2009-08-057	24 bit macros moved to this file from macros.inc
;		Added some new ones (CLR24, ADD24)
;		Please note that all math assumes LITTLE ENDIAN
;
; Used resources:
;		NONE
;
	ifndef	MACROS_24B_INCLUDED
#define	MACROS_24B_INCLUDED		; Macros are included

COPY24	MACRO	SRC,DST			; DST = SRC
	movfw	SRC
	movwf	DST
	movfw	(SRC+1)
	movwf	(DST+1)
	movfw	(SRC+2)
	movwf	(DST+2)
	ENDM

ADD24	MACRO	SRC,DST			; DST = DST + SRC
	movfw	SRC
	addwf   DST,F		   		; low byte
	movfw	(SRC+1) 			; middle byte
	skpnc
	 incfsz	(SRC+1),W
	  addwf	(DST+1),F
	movfw	(SRC+2)				; high byte
	skpnc
	incfsz	(SRC+2),W
	 addwf  (DST+2),F
	ENDM

SUB24	MACRO SRC,DST			; DST = DST - SRC
	movfw	(SRC+0)
    subwf   (DST+0),F 
	movfw   (SRC+1)
	skpc 
     incfsz	(SRC+1),W 
      subwf (DST+1),F
     movfw	(SRC+2)
    skpc 
     incfsz (SRC+2),W
      subwf (DST+2),F 
	ENDM

CLR24	MACRO	DST
	clrf	DST
	clrf	(DST+1)
	clrf	(DST+2)
	ENDM

INC24	MACRO	ARG
    incf    ARG,F
    skpnz
     incf    (ARG+1),F
    skpnz
     incf    (ARG+2),F
	ENDM

#endif
